//**************************************************************************
//**
//**	##   ##    ##    ##   ##   ####     ####   ###     ###
//**	##   ##  ##  ##  ##   ##  ##  ##   ##  ##  ####   ####
//**	 ## ##  ##    ##  ## ##  ##    ## ##    ## ## ## ## ##
//**	 ## ##  ########  ## ##  ##    ## ##    ## ##  ###  ##
//**	  ###   ##    ##   ###    ##  ##   ##  ##  ##       ##
//**	   #    ##    ##    #      ####     ####   ##       ##
//**
//**	Copyright (C) 1999-2001 Jnis Legzdi
//**
//**	This program is free software; you can redistribute it and/or
//**  modify it under the terms of the GNU General Public License
//**  as published by the Free Software Foundation; either version 2
//**  of the License, or (at your option) any later version.
//**
//**	This program is distributed in the hope that it will be useful,
//**  but WITHOUT ANY WARRANTY; without even the implied warranty of
//**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//**  GNU General Public License for more details.
//**
//**************************************************************************
//**
//**	Join net game menu
//**
//**************************************************************************

// MACROS ------------------------------------------------------------------

// CONSTANTS ---------------------------------------------------------------

// TYPES -------------------------------------------------------------------

struct menu_join_game_t
{
	menu_t			menu;
	menutext_t		search;
	menuinputline_t	joinat;
	menutext_t		title;
};

// FUNCTION PROTOTYPES -----------------------------------------------------

void menu_search(void);

// DATA DECLARATIONS -------------------------------------------------------

menu_join_game_t JoinGameMenu;

// CODE --------------------------------------------------------------------

//==========================================================================
//
//	join_at_func
//
//==========================================================================

void join_at_func(menucommon_t *aitem, int msg)
{
   	if (msg == MMSG_ACTIVATE && JoinGameMenu.joinat.value[0])
	{
		CmdBuf_AddText("Connect %s\n", ARR2STR(JoinGameMenu.joinat.value));
	}
}

//==========================================================================
//
//	menu_join_game
//
//==========================================================================

void menu_join_game(void)
{
	int x = 64;
	int y = 40;

    InitMenu(&JoinGameMenu.menu);

	MenuText_InitFunc(&JoinGameMenu.search, x, y, "Search for games...", TEXT_SMALLL, menu_search);
	AddMenuItem(&JoinGameMenu.menu, &JoinGameMenu.search);
	y += 10;

	MenuInputLine_Init(&JoinGameMenu.joinat, x, y, "Join Game At", TEXT_SMALLL, 0);
	JoinGameMenu.joinat.callback = join_at_func;
	JoinGameMenu.joinat.value[0] = 0;
	AddMenuItem(&JoinGameMenu.menu, &JoinGameMenu.joinat);

	MenuText_InitTitle(&JoinGameMenu.title, 160, 24, "JOIN GAME", TEXT_BIGC);
	AddMenuItem(&JoinGameMenu.menu, &JoinGameMenu.title);

    PushMenu(&JoinGameMenu.menu);
}

struct SlistMenu_t
{
	menu_t		menu;
	menuslist_t	list;
	menutext_t	title;
};

SlistMenu_t SlistMenu;

void menu_search(void)
{
    InitMenu(&SlistMenu.menu);

	StartSearch();

	MenuSlist_Init(&SlistMenu.list);
	AddMenuItem(&SlistMenu.menu, &SlistMenu.list);

	MenuText_InitTitle(&SlistMenu.title, 160, 24, "JOIN GAME", TEXT_BIGC);
	AddMenuItem(&SlistMenu.menu, &SlistMenu.title);

    PushMenu(&SlistMenu.menu);
}


