//**************************************************************************
//**
//**	##   ##    ##    ##   ##   ####     ####   ###     ###
//**	##   ##  ##  ##  ##   ##  ##  ##   ##  ##  ####   ####
//**	 ## ##  ##    ##  ## ##  ##    ## ##    ## ## ## ## ##
//**	 ## ##  ########  ## ##  ##    ## ##    ## ##  ###  ##
//**	  ###   ##    ##   ###    ##  ##   ##  ##  ##       ##
//**	   #    ##    ##    #      ####     ####   ##       ##
//**
//**	Copyright (C) 1999-2000 Jnis Legzdi
//**
//**	This program is free software; you can redistribute it and/or
//**  modify it under the terms of the GNU General Public License
//**  as published by the Free Software Foundation; either version 2
//**  of the License, or (at your option) any later version.
//**
//**	This program is distributed in the hope that it will be useful,
//**  but WITHOUT ANY WARRANTY; without even the implied warranty of
//**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//**  GNU General Public License for more details.
//**	
//**************************************************************************

// MACROS ------------------------------------------------------------------

// CONSTANTS ---------------------------------------------------------------

// TYPES -------------------------------------------------------------------

// FUNCTION PROTOTYPES -----------------------------------------------------

// DATA DECLARATIONS -------------------------------------------------------

// CODE --------------------------------------------------------------------

//==========================================================================
//
//	T_ScrollFloor
//
//==========================================================================

void T_ScrollFloor(special_t *scroll)
{
  	scroll->sector->floor.xoffs += scroll->dx;
   	scroll->sector->floor.yoffs += scroll->dy;
}

//==========================================================================
//
//	SpawnScrollingFloor
//
//==========================================================================

void SpawnScrollingFloor(sector_t *sector, int xdir, int ydir, int speed)
{
	special_t*	scroll;

	scroll = NewSpecialThinker(T_ScrollFloor);
	scroll->sector = sector;
   	scroll->dx = itof(xdir) * itof(1 << speed) / 2.0;
	scroll->dy = itof(ydir) * itof(1 << speed) / 2.0;
}

//==========================================================================
//
//	T_ScrollWall
//
//==========================================================================

void T_ScrollWall(special_t *scroll)
{
	level->sides[scroll->index].textureoffset += scroll->dx;
	level->sides[scroll->index].rowoffset += scroll->dy;
}

//==========================================================================
//
//	SpawnWallScroller
//
//==========================================================================

void SpawnWallScroller(line_t *line, int xdir, int ydir)
{
	special_t	*scroll;

    scroll = NewSpecialThinker(T_ScrollWall);
	scroll->index = line->sidenum[0];
	scroll->dx = itof(xdir * line->arg1) / 64.0;
    scroll->dy = itof(ydir * line->arg1) / 64.0;
}
