//**************************************************************************
//**
//**	##   ##    ##    ##   ##   ####     ####   ###     ###
//**	##   ##  ##  ##  ##   ##  ##  ##   ##  ##  ####   ####
//**	 ## ##  ##    ##  ## ##  ##    ## ##    ## ## ## ## ##
//**	 ## ##  ########  ## ##  ##    ## ##    ## ##  ###  ##
//**	  ###   ##    ##   ###    ##  ##   ##  ##  ##       ##
//**	   #    ##    ##    #      ####     ####   ##       ##
//**
//**	Copyright (C) 1999-2001 Jnis Legzdi
//**
//**	This program is free software; you can redistribute it and/or
//**  modify it under the terms of the GNU General Public License
//**  as published by the Free Software Foundation; either version 2
//**  of the License, or (at your option) any later version.
//**
//**	This program is distributed in the hope that it will be useful,
//**  but WITHOUT ANY WARRANTY; without even the implied warranty of
//**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//**  GNU General Public License for more details.
//**	
//**************************************************************************

#include "asm_i386.h"

#ifdef USEASM

.data

	Align4
src_sel:	.long	0
src_ofs:	.long	0
dst_sel:	.long	0
dst_ofs:	.long	0
len:		.long	0

.text

//==========================================================================
//
//
//
//==========================================================================

	Align16
.globl _D_movedatal
_D_movedatal:
	pushl	%ebp
 	pushl	%esi
 	pushl	%edi

	pushw	%ds
	pushw	%es

	movl	src_sel,%eax
	movw	%ax,%ds
	movl	src_ofs,%esi

	movl	dst_sel,%eax
	movw	%ax,%es
	movl	dst_ofs,%edi

	movl	len,%ecx
	cld
	rep
	movsl

	popw	%es
	popw	%ds

	popl	%edi
	popl	%esi
	popl	%ebp
	ret

//==========================================================================
//
//
//
//==========================================================================

	Align16
.globl _Blit_LBL
_Blit_LBL:
	pushl	%ebp
	movl	_ScreenWidth,%ebp
	imull	_PixelBytes,%ebp
	pushl	%edi
	pushl	%esi
	movl	_scrn,%esi
	pushl	%ebx
	movl	%ebp,%edi
	sarl	$2,%edi
	xorl	%ebx,%ebx

	movw	%ds,%ax
	movzwl	%ax,%eax
	movl	%eax,src_sel

	Align16max7
LLoop1:
	movl	_screen,%edx
	movl	%edi,len
	leal	64(%edx),%eax
	movl	(%eax,%ebx,4),%eax
	movl	%eax,dst_ofs
	movl	60(%edx),%eax
	movl	%eax,dst_sel
	movl	%esi,src_ofs
	call	_D_movedatal

	incl	%ebx
	addl	%ebp,%esi
	cmpl	_ScreenHeight,%ebx
	jl		LLoop1

	popl	%ebx
	popl	%esi
	popl	%edi
	popl	%ebp
	addl	$28,%esp
	ret

//==========================================================================
//
//
//
//==========================================================================

	Align16
.globl _Blit_Banked
_Blit_Banked:
	pushl	%ebp
	movl	_ScreenWidth,%ebp
	imull	_PixelBytes,%ebp
	pushl	%edi
	pushl	%esi
	movl	_scrn,%esi
	pushl	%ebx
	movl	%ebp,%edi
	sarl	$2,%edi
	xorl	%ebx,%ebx

	movw	%ds,%ax
	movzwl	%ax,%eax
	movl	%eax,src_sel

	Align16max7
LLoop2:
	movl	_screen,%edx
	movl	%ebx,%eax
	movl	32(%edx),%ecx
	call	*%ecx
	movl	%eax,%ecx
	movl	%edi,len
	movl	%ecx,dst_ofs
	movl	60(%edx),%eax
	movl	%eax,dst_sel

	movl	%esi,src_ofs
	call	_D_movedatal

	addl	%ebp,%esi
	incl	%ebx
	cmpl	_ScreenHeight,%ebx
	jl		LLoop2

	popl	%ebx
	popl	%esi
	popl	%edi
	popl	%ebp
	addl	$28,%esp
	ret

#endif

