;**************************************************************************
;**
;**	   ##   ##    ##    ##   ##   ####     ####   ###     ###
;**	   ##   ##  ##  ##  ##   ##  ##  ##   ##  ##  ####   ####
;**	    ## ##  ##    ##  ## ##  ##    ## ##    ## ## ## ## ##
;**	    ## ##  ########  ## ##  ##    ## ##    ## ##  ###  ##
;**	     ###   ##    ##   ###    ##  ##   ##  ##  ##       ##
;**	      #    ##    ##    #      ####     ####   ##       ##
;**
;**	    Copyright (C) 1999-2001 Jnis Legzdi
;**
;**     This program is free software; you can redistribute it and/or
;**  modify it under the terms of the GNU General Public License
;**  as published by the Free Software Foundation; either version 2
;**  of the License, or (at your option) any later version.
;**
;**	    This program is distributed in the hope that it will be useful,
;**  but WITHOUT ANY WARRANTY; without even the implied warranty of
;**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;**  GNU General Public License for more details.
;**
;**************************************************************************

include asm_i386.inc

_TEXT SEGMENT
 align 4
 public _RunFunction
_RunFunction:
 push ebp
 push edi
 push esi
 push ebx
 mov edi,ds:dword ptr[4+16+esp]
 mov ds:dword ptr[_current_func],edi
 sal edi,4
 add edi,ds:dword ptr[_pr_functions]
 mov eax,ds:dword ptr[4+edi]
 test eax,eax
 jge LINTERPRET_FUNCTION
 sal eax,2
 mov edx,ds:dword ptr[_pr_builtins]
 sub edx,eax
 mov eax,ds:dword ptr[edx]
 call eax
 jmp LEND_RUN_FUNCTION
 align 4
LINTERPRET_FUNCTION:
 mov esi,ds:dword ptr[_pr_stackPtr]
 movzx eax,ds:word ptr[8+edi]
 movzx edx,ds:word ptr[10+edi]
 sal eax,2
 sal edx,2
 sub esi,eax
 mov ebp,esi
 add esi,edx
 mov edi,ds:dword ptr[4+edi]
 sal edi,2
 add edi,ds:dword ptr[_pr_statements]
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPCODE_TABLE:
 dd LOPC_DONE
 dd LOPC_RETURN
 dd LOPC_PUSHNUMBER
 dd LOPC_PUSHPOINTED
 dd LOPC_LOCALADDRESS
 dd LOPC_GLOBALADDRESS
 dd LOPC_ADD
 dd LOPC_SUBTRACT
 dd LOPC_MULTIPLY
 dd LOPC_DIVIDE
 dd LOPC_MODULUS
 dd LOPC_UDIVIDE
 dd LOPC_UMODULUS
 dd LOPC_EQ
 dd LOPC_NE
 dd LOPC_LT
 dd LOPC_GT
 dd LOPC_LE
 dd LOPC_GE
 dd LOPC_ULT
 dd LOPC_UGT
 dd LOPC_ULE
 dd LOPC_UGE
 dd LOPC_ANDLOGICAL
 dd LOPC_ORLOGICAL
 dd LOPC_NEGATELOGICAL
 dd LOPC_ANDBITWISE
 dd LOPC_ORBITWISE
 dd LOPC_XORBITWISE
 dd LOPC_LSHIFT
 dd LOPC_RSHIFT
 dd LOPC_URSHIFT
 dd LOPC_UNARYMINUS
 dd LOPC_BITINVERSE
 dd LOPC_CALL
 dd LOPC_GOTO
 dd LOPC_IFGOTO
 dd LOPC_IFNOTGOTO
 dd LOPC_CASEGOTO
 dd LOPC_DROP
 dd LOPC_ASSIGN
 dd LOPC_ADDVAR
 dd LOPC_SUBVAR
 dd LOPC_MULVAR
 dd LOPC_DIVVAR
 dd LOPC_MODVAR
 dd LOPC_UDIVVAR
 dd LOPC_UMODVAR
 dd LOPC_ANDVAR
 dd LOPC_ORVAR
 dd LOPC_XORVAR
 dd LOPC_LSHIFTVAR
 dd LOPC_RSHIFTVAR
 dd LOPC_URSHIFTVAR
 dd LOPC_PREINC
 dd LOPC_PREDEC
 dd LOPC_POSTINC
 dd LOPC_POSTDEC
 dd LOPC_IFTOPGOTO
 dd LOPC_IFNOTTOPGOTO
 dd LOPC_ASSIGN_DROP
 dd LOPC_ADDVAR_DROP
 dd LOPC_SUBVAR_DROP
 dd LOPC_MULVAR_DROP
 dd LOPC_DIVVAR_DROP
 dd LOPC_MODVAR_DROP
 dd LOPC_UDIVVAR_DROP
 dd LOPC_UMODVAR_DROP
 dd LOPC_ANDVAR_DROP
 dd LOPC_ORVAR_DROP
 dd LOPC_XORVAR_DROP
 dd LOPC_LSHIFTVAR_DROP
 dd LOPC_RSHIFTVAR_DROP
 dd LOPC_URSHIFTVAR_DROP
 dd LOPC_INC_DROP
 dd LOPC_DEC_DROP
 dd LOPC_FADD
 dd LOPC_FSUBTRACT
 dd LOPC_FMULTIPLY
 dd LOPC_FDIVIDE
 dd LOPC_FEQ
 dd LOPC_FNE
 dd LOPC_FLT
 dd LOPC_FGT
 dd LOPC_FLE
 dd LOPC_FGE
 dd LOPC_FUNARYMINUS
 dd LOPC_FADDVAR
 dd LOPC_FSUBVAR
 dd LOPC_FMULVAR
 dd LOPC_FDIVVAR
 dd LOPC_FADDVAR_DROP
 dd LOPC_FSUBVAR_DROP
 dd LOPC_FMULVAR_DROP
 dd LOPC_FDIVVAR_DROP
 dd LOPC_SWAP
 dd LOPC_ICALL
 dd LOPC_VPUSHPOINTED
 dd LOPC_VADD
 dd LOPC_VSUBTRACT
 dd LOPC_VPRESCALE
 dd LOPC_VPOSTSCALE
 dd LOPC_VISCALE
 dd LOPC_VEQ
 dd LOPC_VNE
 dd LOPC_VUNARYMINUS
 dd LOPC_VDROP
 dd LOPC_VASSIGN
 dd LOPC_VADDVAR
 dd LOPC_VSUBVAR
 dd LOPC_VSCALEVAR
 dd LOPC_VISCALEVAR
 dd LOPC_VASSIGN_DROP
 dd LOPC_VADDVAR_DROP
 dd LOPC_VSUBVAR_DROP
 dd LOPC_VSCALEVAR_DROP
 dd LOPC_VISCALEVAR_DROP
 dd LOPC_RETURNL
 dd LOPC_RETURNV
 align 4
LINC_STATEMENT_POINTER:
 add edi,4
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_DONE:
 call near ptr _PR_RFInvalidOpcode
 align 4
LOPC_RETURN:
 mov ds:dword ptr[_pr_stackPtr],ebp
 jmp LEND_RUN_FUNCTION
 align 4
LOPC_PUSHNUMBER:
 mov eax,ds:dword ptr[edi]
 mov ds:dword ptr[esi],eax
 add edi,4
 add esi,4
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_PUSHPOINTED:
 mov eax,ds:dword ptr[-4+esi]
 mov eax,ds:dword ptr[eax]
 mov ds:dword ptr[-4+esi],eax
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_LOCALADDRESS:
 mov eax,ds:dword ptr[edi]
 lea eax,ds:dword ptr[ebp+eax*4]
 mov ds:dword ptr[esi],eax
 add edi,4
 add esi,4
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_GLOBALADDRESS:
 mov eax,ds:dword ptr[edi]
 mov edx,ds:dword ptr[_pr_globaldefs]
 movzx eax,ds:word ptr[2+edx+eax*8]
 sal eax,2
 add eax,ds:dword ptr[_pr_globals]
 mov ds:dword ptr[esi],eax
 add edi,4
 add esi,4
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_ADD:
 sub esi,4
 mov eax,ds:dword ptr[esi]
 add ds:dword ptr[-4+esi],eax
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_SUBTRACT:
 sub esi,4
 mov eax,ds:dword ptr[esi]
 sub ds:dword ptr[-4+esi],eax
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_MULTIPLY:
 sub esi,4
 mov eax,ds:dword ptr[-4+esi]
 imul eax,ds:dword ptr[esi]
 mov ds:dword ptr[-4+esi],eax
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_DIVIDE:
 sub esi,4
 mov eax,ds:dword ptr[-4+esi]
 cdq
 idiv ds:dword ptr[esi]
 mov ds:dword ptr[-4+esi],eax
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_MODULUS:
 sub esi,4
 mov eax,ds:dword ptr[-4+esi]
 cdq
 idiv ds:dword ptr[esi]
 mov ds:dword ptr[-4+esi],edx
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_UDIVIDE:
 sub esi,4
 mov eax,ds:dword ptr[-4+esi]
 xor edx,edx
 div ds:dword ptr[esi]
 mov ds:dword ptr[-4+esi],eax
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_UMODULUS:
 sub esi,4
 mov eax,ds:dword ptr[-4+esi]
 xor edx,edx
 div ds:dword ptr[esi]
 mov ds:dword ptr[-4+esi],edx
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_EQ:
 sub esi,4
 mov eax,ds:dword ptr[esi]
 cmp ds:dword ptr[-4+esi],eax
 sete al
 and eax,1
 mov ds:dword ptr[-4+esi],eax
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_NE:
 sub esi,4
 mov eax,ds:dword ptr[esi]
 cmp ds:dword ptr[-4+esi],eax
 setne al
 and eax,1
 mov ds:dword ptr[-4+esi],eax
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_LT:
 sub esi,4
 mov eax,ds:dword ptr[esi]
 cmp ds:dword ptr[-4+esi],eax
 setl al
 and eax,1
 mov ds:dword ptr[-4+esi],eax
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_GT:
 sub esi,4
 mov eax,ds:dword ptr[esi]
 cmp ds:dword ptr[-4+esi],eax
 setg al
 and eax,1
 mov ds:dword ptr[-4+esi],eax
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_LE:
 sub esi,4
 mov eax,ds:dword ptr[esi]
 cmp ds:dword ptr[-4+esi],eax
 setle al
 and eax,1
 mov ds:dword ptr[-4+esi],eax
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_GE:
 sub esi,4
 mov eax,ds:dword ptr[esi]
 cmp ds:dword ptr[-4+esi],eax
 setge al
 and eax,1
 mov ds:dword ptr[-4+esi],eax
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_ULT:
 sub esi,4
 mov eax,ds:dword ptr[esi]
 cmp ds:dword ptr[-4+esi],eax
 setb al
 and eax,1
 mov ds:dword ptr[-4+esi],eax
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_UGT:
 sub esi,4
 mov eax,ds:dword ptr[esi]
 cmp ds:dword ptr[-4+esi],eax
 seta al
 and eax,1
 mov ds:dword ptr[-4+esi],eax
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_ULE:
 sub esi,4
 mov eax,ds:dword ptr[esi]
 cmp ds:dword ptr[-4+esi],eax
 setbe al
 and eax,1
 mov ds:dword ptr[-4+esi],eax
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_UGE:
 sub esi,4
 mov eax,ds:dword ptr[esi]
 cmp ds:dword ptr[-4+esi],eax
 setae al
 and eax,1
 mov ds:dword ptr[-4+esi],eax
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_ANDLOGICAL:
 sub esi,4
 cmp ds:dword ptr[-4+esi],0
 je LAND_FALSE
 cmp ds:dword ptr[esi],0
 je LAND_FALSE
 mov ds:dword ptr[-4+esi],1
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
LAND_FALSE:
 mov ds:dword ptr[-4+esi],0
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_ORLOGICAL:
 sub esi,4
 cmp ds:dword ptr[-4+esi],0
 jne LOR_TRUE
 cmp ds:dword ptr[esi],0
 jne LOR_TRUE
 mov ds:dword ptr[-4+esi],0
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
LOR_TRUE:
 mov ds:dword ptr[-4+esi],1
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_NEGATELOGICAL:
 cmp ds:dword ptr[-4+esi],0
 sete al
 and eax,1
 mov ds:dword ptr[-4+esi],eax
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_ANDBITWISE:
 sub esi,4
 mov eax,ds:dword ptr[esi]
 and ds:dword ptr[-4+esi],eax
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_ORBITWISE:
 sub esi,4
 mov eax,ds:dword ptr[esi]
 or ds:dword ptr[-4+esi],eax
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_XORBITWISE:
 sub esi,4
 mov eax,ds:dword ptr[esi]
 xor ds:dword ptr[-4+esi],eax
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_LSHIFT:
 sub esi,4
 mov ecx,ds:dword ptr[esi]
 sal ds:dword ptr[-4+esi],cl
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_RSHIFT:
 sub esi,4
 mov ecx,ds:dword ptr[esi]
 sar ds:dword ptr[-4+esi],cl
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_URSHIFT:
 sub esi,4
 mov ecx,ds:dword ptr[esi]
 shr ds:dword ptr[-4+esi],cl
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_UNARYMINUS:
 neg ds:dword ptr[-4+esi]
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_BITINVERSE:
 not ds:dword ptr[-4+esi]
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_CALL:
 mov ds:dword ptr[_pr_stackPtr],esi
 add esp,offset -12
 push ds:dword ptr[edi]
 add edi,4
 call near ptr _RunFunction
 add esp,16
 mov eax,ds:dword ptr[4+16+esp]
 mov ds:dword ptr[_current_func],eax
 mov esi,ds:dword ptr[_pr_stackPtr]
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_GOTO:
 mov edi,ds:dword ptr[edi]
 sal edi,2
 add edi,ds:dword ptr[_pr_statements]
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_IFGOTO:
 sub esi,4
 cmp ds:dword ptr[esi],0
 je LINC_STATEMENT_POINTER
 mov edi,ds:dword ptr[edi]
 sal edi,2
 add edi,ds:dword ptr[_pr_statements]
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_IFNOTGOTO:
 sub esi,4
 cmp ds:dword ptr[esi],0
 jne LINC_STATEMENT_POINTER
 mov edi,ds:dword ptr[edi]
 sal edi,2
 add edi,ds:dword ptr[_pr_statements]
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_CASEGOTO:
 mov eax,ds:dword ptr[edi]
 add edi,4
 cmp eax,ds:dword ptr[-4+esi]
 jne LINC_STATEMENT_POINTER
 mov edi,ds:dword ptr[edi]
 sub esi,4
 sal edi,2
 add edi,ds:dword ptr[_pr_statements]
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_DROP:
 sub esi,4
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_ASSIGN:
 sub esi,4
 mov edx,ds:dword ptr[-4+esi]
 mov eax,ds:dword ptr[esi]
 mov ds:dword ptr[edx],eax
 mov ds:dword ptr[-4+esi],eax
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_ADDVAR:
 sub esi,4
 mov edx,ds:dword ptr[-4+esi]
 mov eax,ds:dword ptr[esi]
 add ds:dword ptr[edx],eax
 mov eax,ds:dword ptr[edx]
 mov ds:dword ptr[-4+esi],eax
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_SUBVAR:
 sub esi,4
 mov edx,ds:dword ptr[-4+esi]
 mov eax,ds:dword ptr[esi]
 sub ds:dword ptr[edx],eax
 mov eax,ds:dword ptr[edx]
 mov ds:dword ptr[-4+esi],eax
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_MULVAR:
 sub esi,4
 mov edx,ds:dword ptr[-4+esi]
 mov eax,ds:dword ptr[esi]
 imul eax,ds:dword ptr[edx]
 mov ds:dword ptr[edx],eax
 mov ds:dword ptr[-4+esi],eax
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_DIVVAR:
 sub esi,4
 mov ecx,ds:dword ptr[-4+esi]
 mov eax,ds:dword ptr[ecx]
 cdq
 idiv ds:dword ptr[esi]
 mov ds:dword ptr[ecx],eax
 mov ds:dword ptr[-4+esi],eax
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_MODVAR:
 sub esi,4
 mov ecx,ds:dword ptr[-4+esi]
 mov eax,ds:dword ptr[ecx]
 cdq
 idiv ds:dword ptr[esi]
 mov ds:dword ptr[ecx],edx
 mov ds:dword ptr[-4+esi],edx
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_UDIVVAR:
 sub esi,4
 mov ecx,ds:dword ptr[-4+esi]
 mov eax,ds:dword ptr[ecx]
 xor edx,edx
 div ds:dword ptr[esi]
 mov ds:dword ptr[ecx],eax
 mov ds:dword ptr[-4+esi],eax
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_UMODVAR:
 sub esi,4
 mov ecx,ds:dword ptr[-4+esi]
 mov eax,ds:dword ptr[ecx]
 xor edx,edx
 div ds:dword ptr[esi]
 mov ds:dword ptr[ecx],edx
 mov ds:dword ptr[-4+esi],edx
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_ANDVAR:
 sub esi,4
 mov edx,ds:dword ptr[-4+esi]
 mov eax,ds:dword ptr[esi]
 and ds:dword ptr[edx],eax
 mov eax,ds:dword ptr[edx]
 mov ds:dword ptr[-4+esi],eax
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_ORVAR:
 sub esi,4
 mov edx,ds:dword ptr[-4+esi]
 mov eax,ds:dword ptr[esi]
 or ds:dword ptr[edx],eax
 mov eax,ds:dword ptr[edx]
 mov ds:dword ptr[-4+esi],eax
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_XORVAR:
 sub esi,4
 mov edx,ds:dword ptr[-4+esi]
 mov eax,ds:dword ptr[esi]
 xor ds:dword ptr[edx],eax
 mov eax,ds:dword ptr[edx]
 mov ds:dword ptr[-4+esi],eax
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_LSHIFTVAR:
 sub esi,4
 mov edx,ds:dword ptr[-4+esi]
 mov ecx,ds:dword ptr[esi]
 sal ds:dword ptr[edx],cl
 mov eax,ds:dword ptr[edx]
 mov ds:dword ptr[-4+esi],eax
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_RSHIFTVAR:
 sub esi,4
 mov edx,ds:dword ptr[-4+esi]
 mov ecx,ds:dword ptr[esi]
 sar ds:dword ptr[edx],cl
 mov eax,ds:dword ptr[edx]
 mov ds:dword ptr[-4+esi],eax
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_URSHIFTVAR:
 sub esi,4
 mov edx,ds:dword ptr[-4+esi]
 mov ecx,ds:dword ptr[esi]
 shr ds:dword ptr[edx],cl
 mov eax,ds:dword ptr[edx]
 mov ds:dword ptr[-4+esi],eax
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_PREINC:
 mov edx,ds:dword ptr[-4+esi]
 inc ds:dword ptr[edx]
 mov eax,ds:dword ptr[edx]
 mov ds:dword ptr[-4+esi],eax
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_PREDEC:
 mov edx,ds:dword ptr[-4+esi]
 dec ds:dword ptr[edx]
 mov eax,ds:dword ptr[edx]
 mov ds:dword ptr[-4+esi],eax
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_POSTINC:
 mov edx,ds:dword ptr[-4+esi]
 mov eax,ds:dword ptr[edx]
 mov ds:dword ptr[-4+esi],eax
 inc ds:dword ptr[edx]
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_POSTDEC:
 mov edx,ds:dword ptr[-4+esi]
 mov eax,ds:dword ptr[edx]
 mov ds:dword ptr[-4+esi],eax
 dec ds:dword ptr[edx]
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_IFTOPGOTO:
 cmp ds:dword ptr[-4+esi],0
 je LINC_STATEMENT_POINTER
 mov edi,ds:dword ptr[edi]
 sal edi,2
 add edi,ds:dword ptr[_pr_statements]
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_IFNOTTOPGOTO:
 cmp ds:dword ptr[-4+esi],0
 jne LINC_STATEMENT_POINTER
 mov edi,ds:dword ptr[edi]
 sal edi,2
 add edi,ds:dword ptr[_pr_statements]
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_ASSIGN_DROP:
 sub esi,4
 mov edx,ds:dword ptr[-4+esi]
 mov eax,ds:dword ptr[esi]
 mov ds:dword ptr[edx],eax
 sub esi,4
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_ADDVAR_DROP:
 sub esi,4
 mov edx,ds:dword ptr[-4+esi]
 mov eax,ds:dword ptr[esi]
 add ds:dword ptr[edx],eax
 sub esi,4
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_SUBVAR_DROP:
 sub esi,4
 mov edx,ds:dword ptr[-4+esi]
 mov eax,ds:dword ptr[esi]
 sub ds:dword ptr[edx],eax
 sub esi,4
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_MULVAR_DROP:
 sub esi,4
 mov edx,ds:dword ptr[-4+esi]
 mov eax,ds:dword ptr[edx]
 imul eax,ds:dword ptr[esi]
 mov ds:dword ptr[edx],eax
 sub esi,4
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_DIVVAR_DROP:
 sub esi,4
 mov ecx,ds:dword ptr[-4+esi]
 mov eax,ds:dword ptr[ecx]
 cdq
 idiv ds:dword ptr[esi]
 mov ds:dword ptr[ecx],eax
 sub esi,4
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_MODVAR_DROP:
 sub esi,4
 mov ecx,ds:dword ptr[-4+esi]
 mov eax,ds:dword ptr[ecx]
 cdq
 idiv ds:dword ptr[esi]
 mov ds:dword ptr[ecx],edx
 sub esi,4
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_UDIVVAR_DROP:
 sub esi,4
 mov ecx,ds:dword ptr[-4+esi]
 mov eax,ds:dword ptr[ecx]
 xor edx,edx
 div ds:dword ptr[esi]
 mov ds:dword ptr[ecx],eax
 sub esi,4
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_UMODVAR_DROP:
 sub esi,4
 mov ecx,ds:dword ptr[-4+esi]
 mov eax,ds:dword ptr[ecx]
 xor edx,edx
 div ds:dword ptr[esi]
 mov ds:dword ptr[ecx],edx
 sub esi,4
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_ANDVAR_DROP:
 sub esi,4
 mov eax,ds:dword ptr[-4+esi]
 mov ecx,ds:dword ptr[esi]
 and ds:dword ptr[eax],ecx
 sub esi,4
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_ORVAR_DROP:
 sub esi,4
 mov eax,ds:dword ptr[-4+esi]
 mov ecx,ds:dword ptr[esi]
 or ds:dword ptr[eax],ecx
 sub esi,4
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_XORVAR_DROP:
 sub esi,4
 mov eax,ds:dword ptr[-4+esi]
 mov ecx,ds:dword ptr[esi]
 xor ds:dword ptr[eax],ecx
 sub esi,4
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_LSHIFTVAR_DROP:
 sub esi,4
 mov eax,ds:dword ptr[-4+esi]
 mov ecx,ds:dword ptr[esi]
 sal ds:dword ptr[eax],cl
 sub esi,4
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_RSHIFTVAR_DROP:
 sub esi,4
 mov eax,ds:dword ptr[-4+esi]
 mov ecx,ds:dword ptr[esi]
 sar ds:dword ptr[eax],cl
 sub esi,4
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_URSHIFTVAR_DROP:
 sub esi,4
 mov eax,ds:dword ptr[-4+esi]
 mov ecx,ds:dword ptr[esi]
 shr ds:dword ptr[eax],cl
 sub esi,4
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_INC_DROP:
 mov edx,ds:dword ptr[-4+esi]
 inc ds:dword ptr[edx]
 sub esi,4
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_DEC_DROP:
 mov edx,ds:dword ptr[-4+esi]
 dec ds:dword ptr[edx]
 sub esi,4
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_FADD:
 sub esi,4
 fld ds:dword ptr[-4+esi]
 fadd ds:dword ptr[esi]
 fstp ds:dword ptr[-4+esi]
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_FSUBTRACT:
 sub esi,4
 fld ds:dword ptr[-4+esi]
 fsub ds:dword ptr[esi]
 fstp ds:dword ptr[-4+esi]
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_FMULTIPLY:
 sub esi,4
 fld ds:dword ptr[-4+esi]
 fmul ds:dword ptr[esi]
 fstp ds:dword ptr[-4+esi]
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_FDIVIDE:
 sub esi,4
 fld ds:dword ptr[-4+esi]
 fdiv ds:dword ptr[esi]
 fstp ds:dword ptr[-4+esi]
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_FEQ:
 sub esi,4
 fld ds:dword ptr[-4+esi]
 fcomp ds:dword ptr[esi]
 fnstsw ax
 sahf
 sete dl
 and edx,1
 mov ds:dword ptr[-4+esi],edx
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_FNE:
 sub esi,4
 fld ds:dword ptr[-4+esi]
 fcomp ds:dword ptr[esi]
 fnstsw ax
 sahf
 setne dl
 and edx,1
 mov ds:dword ptr[-4+esi],edx
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_FLT:
 sub esi,4
 fld ds:dword ptr[-4+esi]
 fcomp ds:dword ptr[esi]
 fnstsw ax
 sahf
 setb dl
 and edx,1
 mov ds:dword ptr[-4+esi],edx
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_FGT:
 sub esi,4
 fld ds:dword ptr[-4+esi]
 fcomp ds:dword ptr[esi]
 fnstsw ax
 sahf
 seta dl
 and edx,1
 mov ds:dword ptr[-4+esi],edx
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_FLE:
 sub esi,4
 fld ds:dword ptr[-4+esi]
 fcomp ds:dword ptr[esi]
 fnstsw ax
 sahf
 setbe dl
 and edx,1
 mov ds:dword ptr[-4+esi],edx
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_FGE:
 sub esi,4
 fld ds:dword ptr[-4+esi]
 fcomp ds:dword ptr[esi]
 fnstsw ax
 sahf
 setnb dl
 and edx,1
 mov ds:dword ptr[-4+esi],edx
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_FUNARYMINUS:
 fld ds:dword ptr[-4+esi]
 fchs
 fstp ds:dword ptr[-4+esi]
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_FADDVAR:
 sub esi,4
 mov eax,ds:dword ptr[-4+esi]
 fld ds:dword ptr[eax]
 fadd ds:dword ptr[esi]
 fstp ds:dword ptr[eax]
 mov eax,ds:dword ptr[eax]
 mov ds:dword ptr[-4+esi],eax
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_FSUBVAR:
 sub esi,4
 mov eax,ds:dword ptr[-4+esi]
 fld ds:dword ptr[eax]
 fsub ds:dword ptr[esi]
 fstp ds:dword ptr[eax]
 mov eax,ds:dword ptr[eax]
 mov ds:dword ptr[-4+esi],eax
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_FMULVAR:
 sub esi,4
 mov eax,ds:dword ptr[-4+esi]
 fld ds:dword ptr[eax]
 fmul ds:dword ptr[esi]
 fstp ds:dword ptr[eax]
 mov eax,ds:dword ptr[eax]
 mov ds:dword ptr[-4+esi],eax
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_FDIVVAR:
 sub esi,4
 mov eax,ds:dword ptr[-4+esi]
 fld ds:dword ptr[eax]
 fdiv ds:dword ptr[esi]
 fstp ds:dword ptr[eax]
 mov eax,ds:dword ptr[eax]
 mov ds:dword ptr[-4+esi],eax
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_FADDVAR_DROP:
 sub esi,4
 mov eax,ds:dword ptr[-4+esi]
 fld ds:dword ptr[eax]
 fadd ds:dword ptr[esi]
 fstp ds:dword ptr[eax]
 sub esi,4
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_FSUBVAR_DROP:
 sub esi,4
 mov eax,ds:dword ptr[-4+esi]
 fld ds:dword ptr[eax]
 fsub ds:dword ptr[esi]
 fstp ds:dword ptr[eax]
 sub esi,4
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_FMULVAR_DROP:
 sub esi,4
 mov eax,ds:dword ptr[-4+esi]
 fld ds:dword ptr[eax]
 fmul ds:dword ptr[esi]
 fstp ds:dword ptr[eax]
 sub esi,4
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_FDIVVAR_DROP:
 sub esi,4
 mov eax,ds:dword ptr[-4+esi]
 fld ds:dword ptr[eax]
 fdiv ds:dword ptr[esi]
 fstp ds:dword ptr[eax]
 sub esi,4
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_SWAP:
 mov eax,ds:dword ptr[-8+esi]
 mov edx,ds:dword ptr[-4+esi]
 mov ds:dword ptr[-8+esi],edx
 mov ds:dword ptr[-4+esi],eax
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_ICALL:
 sub esi,4
 add esp,offset -12
 push ds:dword ptr[esi]
 mov ds:dword ptr[_pr_stackPtr],esi
 call near ptr _RunFunction
 add esp,16
 mov eax,ds:dword ptr[4+16+esp]
 mov ds:dword ptr[_current_func],eax
 mov esi,ds:dword ptr[_pr_stackPtr]
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_VPUSHPOINTED:
 add esi,8
 mov edx,ds:dword ptr[-12+esi]
 mov eax,ds:dword ptr[edx]
 mov ds:dword ptr[-12+esi],eax
 mov eax,ds:dword ptr[4+edx]
 mov ds:dword ptr[-8+esi],eax
 mov eax,ds:dword ptr[8+edx]
 mov ds:dword ptr[-4+esi],eax
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_VADD:
 fld ds:dword ptr[-24+esi]
 fadd ds:dword ptr[-12+esi]
 fstp ds:dword ptr[-24+esi]
 fld ds:dword ptr[-20+esi]
 fadd ds:dword ptr[-8+esi]
 fstp ds:dword ptr[-20+esi]
 fld ds:dword ptr[-16+esi]
 fadd ds:dword ptr[-4+esi]
 fstp ds:dword ptr[-16+esi]
 add esi,offset -12
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_VSUBTRACT:
 fld ds:dword ptr[-24+esi]
 fsub ds:dword ptr[-12+esi]
 fstp ds:dword ptr[-24+esi]
 fld ds:dword ptr[-20+esi]
 fsub ds:dword ptr[-8+esi]
 fstp ds:dword ptr[-20+esi]
 fld ds:dword ptr[-16+esi]
 fsub ds:dword ptr[-4+esi]
 fstp ds:dword ptr[-16+esi]
 add esi,offset -12
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_VPRESCALE:
 fld ds:dword ptr[-16+esi]
 fld st(0)
 fld st(1)
 fmul ds:dword ptr[-12+esi]
 fstp ds:dword ptr[-16+esi]
 fmul ds:dword ptr[-8+esi]
 fstp ds:dword ptr[-12+esi]
 fmul ds:dword ptr[-4+esi]
 fstp ds:dword ptr[-8+esi]
 sub esi,4
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_VPOSTSCALE:
 fld ds:dword ptr[-4+esi]
 fld st(0)
 fld st(1)
 fmul ds:dword ptr[-16+esi]
 fstp ds:dword ptr[-16+esi]
 fmul ds:dword ptr[-12+esi]
 fstp ds:dword ptr[-12+esi]
 fmul ds:dword ptr[-8+esi]
 fstp ds:dword ptr[-8+esi]
 sub esi,4
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_VISCALE:
 fld ds:dword ptr[-16+esi]
 fdiv ds:dword ptr[-4+esi]
 fstp ds:dword ptr[-16+esi]
 fld ds:dword ptr[-12+esi]
 fdiv ds:dword ptr[-4+esi]
 fstp ds:dword ptr[-12+esi]
 fld ds:dword ptr[-8+esi]
 fdiv ds:dword ptr[-4+esi]
 fstp ds:dword ptr[-8+esi]
 sub esi,4
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_VEQ:
 fld ds:dword ptr[-24+esi]
 fld ds:dword ptr[-12+esi]
fucompp
 fnstsw ax
 sahf
 jne VEQ_FALSE
 fld ds:dword ptr[-20+esi]
 fld ds:dword ptr[-8+esi]
fucompp
 fnstsw ax
 sahf
 jne VEQ_FALSE
 fld ds:dword ptr[-16+esi]
 fld ds:dword ptr[-4+esi]
fucompp
 fnstsw ax
 sahf
 jne VEQ_FALSE
 mov ds:dword ptr[-24+esi],1
 add esi,offset -20
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
VEQ_FALSE:
 mov ds:dword ptr[-24+esi],0
 add esi,offset -20
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_VNE:
 fld ds:dword ptr[-24+esi]
 fld ds:dword ptr[-12+esi]
fucompp
 fnstsw ax
 sahf
 jne LVNE_TRUE
 fld ds:dword ptr[-20+esi]
 fld ds:dword ptr[-8+esi]
fucompp
 fnstsw ax
 sahf
 jne LVNE_TRUE
 fld ds:dword ptr[-16+esi]
 fld ds:dword ptr[-4+esi]
fucompp
 fnstsw ax
 sahf
 jne LVNE_TRUE
 mov ds:dword ptr[-24+esi],0
 add esi,offset -20
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
LVNE_TRUE:
 mov ds:dword ptr[-24+esi],1
 add esi,offset -20
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_VUNARYMINUS:
 fld ds:dword ptr[-12+esi]
 fchs
 fstp ds:dword ptr[-12+esi]
 fld ds:dword ptr[-8+esi]
 fchs
 fstp ds:dword ptr[-8+esi]
 fld ds:dword ptr[-4+esi]
 fchs
 fstp ds:dword ptr[-4+esi]
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_VDROP:
 add esi,offset -12
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_VASSIGN:
 mov edx,ds:dword ptr[-16+esi]
 mov eax,ds:dword ptr[-12+esi]
 mov ds:dword ptr[edx],eax
 mov ds:dword ptr[-16+esi],eax
 mov eax,ds:dword ptr[-8+esi]
 mov ds:dword ptr[4+edx],eax
 mov ds:dword ptr[-12+esi],eax
 mov eax,ds:dword ptr[-4+esi]
 mov ds:dword ptr[8+edx],eax
 mov ds:dword ptr[-8+esi],eax
 sub esi,4
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_VADDVAR:
 mov edx,ds:dword ptr[-16+esi]
 fld ds:dword ptr[edx]
 fadd ds:dword ptr[-12+esi]
 fst ds:dword ptr[edx]
 fstp ds:dword ptr[-16+esi]
 fld ds:dword ptr[4+edx]
 fadd ds:dword ptr[-8+esi]
 fst ds:dword ptr[4+edx]
 fstp ds:dword ptr[-12+esi]
 fld ds:dword ptr[8+edx]
 fadd ds:dword ptr[-4+esi]
 fst ds:dword ptr[8+edx]
 fstp ds:dword ptr[-8+esi]
 sub esi,4
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_VSUBVAR:
 mov edx,ds:dword ptr[-16+esi]
 fld ds:dword ptr[edx]
 fsub ds:dword ptr[-12+esi]
 fst ds:dword ptr[edx]
 fstp ds:dword ptr[-16+esi]
 fld ds:dword ptr[4+edx]
 fsub ds:dword ptr[-8+esi]
 fst ds:dword ptr[4+edx]
 fstp ds:dword ptr[-12+esi]
 fld ds:dword ptr[8+edx]
 fsub ds:dword ptr[-4+esi]
 fst ds:dword ptr[8+edx]
 fstp ds:dword ptr[-8+esi]
 sub esi,4
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_VSCALEVAR:
 add esi,4
 mov edx,ds:dword ptr[-12+esi]
 fld ds:dword ptr[-8+esi]
 fld ds:dword ptr[edx]
 fmul st,st(1)
 fst ds:dword ptr[edx]
 fstp ds:dword ptr[-12+esi]
 fld ds:dword ptr[4+edx]
 fmul st,st(1)
 fst ds:dword ptr[4+edx]
 fstp ds:dword ptr[-8+esi]
 fmul ds:dword ptr[8+edx]
 fst ds:dword ptr[8+edx]
 fstp ds:dword ptr[-4+esi]
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_VISCALEVAR:
 add esi,4
 mov edx,ds:dword ptr[-12+esi]
 fld ds:dword ptr[-8+esi]
 fld ds:dword ptr[edx]
 fdiv st,st(1)
 fst ds:dword ptr[edx]
 fstp ds:dword ptr[-12+esi]
 fld ds:dword ptr[4+edx]
 fdiv st,st(1)
 fst ds:dword ptr[4+edx]
 fstp ds:dword ptr[-8+esi]
 fdivr ds:dword ptr[8+edx]
 fst ds:dword ptr[8+edx]
 fstp ds:dword ptr[-4+esi]
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_VASSIGN_DROP:
 mov edx,ds:dword ptr[-16+esi]
 mov eax,ds:dword ptr[-12+esi]
 mov ds:dword ptr[edx],eax
 mov eax,ds:dword ptr[-8+esi]
 mov ds:dword ptr[4+edx],eax
 mov eax,ds:dword ptr[-4+esi]
 mov ds:dword ptr[8+edx],eax
 add esi,offset -16
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_VADDVAR_DROP:
 mov edx,ds:dword ptr[-16+esi]
 fld ds:dword ptr[edx]
 fadd ds:dword ptr[-12+esi]
 fstp ds:dword ptr[edx]
 fld ds:dword ptr[4+edx]
 fadd ds:dword ptr[-8+esi]
 fstp ds:dword ptr[4+edx]
 fld ds:dword ptr[8+edx]
 fadd ds:dword ptr[-4+esi]
 fstp ds:dword ptr[8+edx]
 add esi,offset -16
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_VSUBVAR_DROP:
 mov edx,ds:dword ptr[-16+esi]
 fld ds:dword ptr[edx]
 fsub ds:dword ptr[-12+esi]
 fstp ds:dword ptr[edx]
 fld ds:dword ptr[4+edx]
 fsub ds:dword ptr[-8+esi]
 fstp ds:dword ptr[4+edx]
 fld ds:dword ptr[8+edx]
 fsub ds:dword ptr[-4+esi]
 fstp ds:dword ptr[8+edx]
 add esi,offset -16
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_VSCALEVAR_DROP:
 mov edx,ds:dword ptr[-8+esi]
 fld ds:dword ptr[-4+esi]
 fld ds:dword ptr[edx]
 fmul st,st(1)
 fstp ds:dword ptr[edx]
 fld ds:dword ptr[4+edx]
 fmul st,st(1)
 fstp ds:dword ptr[4+edx]
 fmul ds:dword ptr[8+edx]
 fstp ds:dword ptr[8+edx]
 add esi,offset -8
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_VISCALEVAR_DROP:
 mov edx,ds:dword ptr[-8+esi]
 fld ds:dword ptr[-4+esi]
 fld ds:dword ptr[edx]
 fdiv st,st(1)
 fstp ds:dword ptr[edx]
 fld ds:dword ptr[4+edx]
 fdiv st,st(1)
 fstp ds:dword ptr[4+edx]
 fdivr ds:dword ptr[8+edx]
 fstp ds:dword ptr[8+edx]
 add esi,offset -8
 mov eax,ds:dword ptr[edi]
 add edi,4
 jmp dword ptr[LOPCODE_TABLE+eax*4]
 align 4
LOPC_RETURNL:
 mov eax,ds:dword ptr[-4+esi]
 mov ds:dword ptr[ebp],eax
 lea esi,ds:dword ptr[4+ebp]
 mov ds:dword ptr[_pr_stackPtr],esi
 jmp LEND_RUN_FUNCTION
 align 4
LOPC_RETURNV:
 mov eax,ds:dword ptr[-12+esi]
 mov ds:dword ptr[ebp],eax
 mov eax,ds:dword ptr[-8+esi]
 mov ds:dword ptr[4+ebp],eax
 mov eax,ds:dword ptr[-4+esi]
 mov ds:dword ptr[8+ebp],eax
 lea esi,ds:dword ptr[12+ebp]
 mov ds:dword ptr[_pr_stackPtr],esi
 jmp LEND_RUN_FUNCTION
LEND_RUN_FUNCTION:
 pop ebx
 pop esi
 pop edi
 pop ebp
 ret
_TEXT ENDS
 END
