//**************************************************************************
//**
//**	##   ##    ##    ##   ##   ####     ####   ###     ###
//**	##   ##  ##  ##  ##   ##  ##  ##   ##  ##  ####   ####
//**	 ## ##  ##    ##  ## ##  ##    ## ##    ## ## ## ## ##
//**	 ## ##  ########  ## ##  ##    ## ##    ## ##  ###  ##
//**	  ###   ##    ##   ###    ##  ##   ##  ##  ##       ##
//**	   #    ##    ##    #      ####     ####   ##       ##
//**
//**	Copyright (C) 1999-2001 Jnis Legzdi
//**
//**	This program is free software; you can redistribute it and/or
//**  modify it under the terms of the GNU General Public License
//**  as published by the Free Software Foundation; either version 2
//**  of the License, or (at your option) any later version.
//**
//**	This program is distributed in the hope that it will be useful,
//**  but WITHOUT ANY WARRANTY; without even the implied warranty of
//**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//**  GNU General Public License for more details.
//**	
//**************************************************************************

#ifndef _SYSTEM_H
#define _SYSTEM_H

// HEADER FILES ------------------------------------------------------------

// MACROS ------------------------------------------------------------------

// State updates, number of tics / second.
#define TICRATE		35

// TYPES -------------------------------------------------------------------

// PUBLIC FUNCTION PROTOTYPES ----------------------------------------------

int Sys_FileOpenRead(const char* filename);
int Sys_FileOpenWrite(const char* filename);
int Sys_FileRead(int handle, void* buf, int size);
int Sys_FileWrite(int handle, const void* buf, int size);
int Sys_FileSize(int handle);
int Sys_FileSeek(int handle, int offset);
int Sys_FileClose(int handle);
int Sys_FileExists(const char* filename);

int Sys_CreateDirectory(const char* path);

void* Sys_ZoneBase(int* size);

void Sys_Error(const char *error, ...) __attribute__ ((noreturn))
	__attribute__ ((format(printf, 1, 2)));
void Sys_Quit(void) __attribute__ ((noreturn));
void Sys_Shutdown(void);

double Sys_Time(void);

char *Sys_ConsoleInput(void);

extern "C" {

void Sys_LowFPPrecision(void);
void Sys_HighFPPrecision(void);

}

//
// memory protection
//
void Sys_MakeCodeWriteable(unsigned long startaddr, unsigned long length);

// PUBLIC DATA DECLARATIONS ------------------------------------------------

#endif
